package com.unipi.talepis;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class Main {

    public static void main(String[] args) {
	    Professor p1 = new Professor();
	    Field[] fields = p1.getClass().getDeclaredFields();
	    List<String> fieldNames = Arrays.stream(fields)
                .map(field -> field.getName())
                .collect(Collectors.toList());
        //System.out.println(fieldNames);
        try {
            Class professorClass = Class.forName("com.unipi.talepis.Main");
            System.out.println(Modifier.toString(professorClass.getModifiers()));
            Package p = Professor.class.getPackage();
            System.out.println(p.getName());
            Class<? super Professor> professorSuperClass = Professor.class.getSuperclass();
            System.out.println(professorSuperClass.getSimpleName());
            Class[] professorInterfaces = Professor.class.getInterfaces();
            for (Class c :
                    professorInterfaces) {
                System.out.println(c.getSimpleName());
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
    }
}
interface IEat{
    void eat();
}
interface ISpeak{
    void speak();
}
class Human{
    int age;
}
class Professor extends Human implements IEat,ISpeak{
    private int officeNumber;

    public Professor() {
    }

    public Professor(int officeNumber) {
        this.officeNumber = officeNumber;
    }

    @Override
    public void eat() {

    }

    @Override
    public void speak() {

    }
}
